<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  
  
  <link rel="shortcut icon" href="../img/favicon.ico">
  <title>Fortran Language - LFortran Documentation</title>
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato:400,700|Roboto+Slab:400,700|Inconsolata:400,700" />

  <link rel="stylesheet" href="../css/theme.css" />
  <link rel="stylesheet" href="../css/theme_extra.css" />
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/10.5.0/styles/github.min.css" />
  <link href="../ansi.css" rel="stylesheet" />
  
  <script>
    // Current page data
    var mkdocs_page_name = "Fortran Language";
    var mkdocs_page_input_path = "language.md";
    var mkdocs_page_url = null;
  </script>
  
  <script src="../js/jquery-2.1.1.min.js" defer></script>
  <script src="../js/modernizr-2.8.3.min.js" defer></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/10.5.0/highlight.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/10.5.0/languages/fortran.min.js"></script>
  <script>hljs.initHighlightingOnLoad();</script> 
</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side stickynav">
    <div class="wy-side-scroll">
      <div class="wy-side-nav-search">
        <a href=".." class="icon icon-home"> LFortran Documentation</a>
        <div role="search">
  <form id ="rtd-search-form" class="wy-form" action="../search.html" method="get">
      <input type="text" name="q" placeholder="Search docs" title="Type search term here" />
  </form>
</div>
      </div>

      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
                <ul>
                    <li class="toctree-l1"><a class="reference internal" href="..">Home</a>
                    </li>
                </ul>
                <ul>
                    <li class="toctree-l1"><a class="reference internal" href="../installation/">Installation</a>
                    </li>
                </ul>
                <ul class="current">
                    <li class="toctree-l1 current"><a class="reference internal current" href="./">Fortran Language</a>
    <ul class="current">
    <li class="toctree-l2"><a class="reference internal" href="#background-and-motivation">Background and Motivation</a>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#how-to-learn-fortran">How to Learn Fortran</a>
    </li>
    </ul>
                    </li>
                </ul>
                <ul>
                    <li class="toctree-l1"><a class="reference internal" href="../progress/">LFortran Development Status</a>
                    </li>
                </ul>
                <p class="caption"><span class="caption-text">Developer's Guide</span></p>
                <ul>
                    <li class="toctree-l1"><a class="reference internal" href="../design/">LFortran Design</a>
                    </li>
                    <li class="toctree-l1"><a class="" href="../developer_tutorial.md">None</a>
                    </li>
                    <li class="toctree-l1"><a class="" href="../AST and ASR.md">None</a>
                    </li>
                    <li class="toctree-l1"><a class="reference internal" href="../contribution/">Contributing</a>
                    </li>
                </ul>
      </div>
    </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="..">LFortran Documentation</a>
      </nav>

      
      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="..">Docs</a> &raquo;</li>
    
      
    
    <li>Fortran Language</li>
    <li class="wy-breadcrumbs-aside">
      
    </li>
  </ul>
  
  <hr/>
</div>

          <div role="main">
            <div class="section">
              
                <h1 id="fortran-language">Fortran Language</h1>
<h2 id="background-and-motivation">Background and Motivation</h2>
<p>Fortran was designed from the ground up to naturally and simply translate
mathematics to code that compiles and runs at maximum speed. And being
specifically targeted for such fundamentally computational tasks, it contains a
broad range of key functionality within the language itself, standard across
all platforms, with no need for external libraries that may or may not be well
optimized or maintained, at present or down the road.</p>
<p>Some highlights:</p>
<ul>
<li>Multidimensional arrays which can be allocated and indexed as the
  math/science dictates (not restricted to start at 0 or 1) and can be sliced
  as desired (as, e.g., in MATLAB);</li>
<li>Operators which operate naturally upon the aforementioned arrays/matrices, as
  they do scalars;</li>
<li>Complex numbers;</li>
<li>Special functions;</li>
<li>Structures and pointers for more general data representation.</li>
</ul>
<p>Because the essentials are contained in the language itself, it is simple to
read and write, without need of choosing from among or deciphering a
proliferation of external classes to do the same thing. And because the
essentials are self-contained, compilers can provide detailed compile-time
(e.g., argument mismatch) and run-time (e.g., memory access) checks, as well as
highly optimized executables, directly from natural, readable code without need
of extensive optimization heroics by the developer.</p>
<p>See our blog posts for more information:</p>
<ul>
<li><a href="https://lfortran.org/blog/2019/04/why-we-created-lfortran/">Why We Created LFortran</a></li>
<li><a href="https://lfortran.org/blog/2019/05/why-to-use-fortran-for-new-projects/">Why to Use Fortran For New Projects</a></li>
</ul>
<h2 id="how-to-learn-fortran">How to Learn Fortran</h2>
<p>Fortran is relatively quick to learn because it is so much simpler and smaller
than C/C++ (in practice, that is, with all needed libraries included).
If you are interested in learning more, please see our webpage at
<a href="https://www.fortran90.org/">fortran90.org</a> with recommended practices for writing code, side by side
comparison with Python/NumPy, links to other online Fortran resources and
books, and an FAQ.</p>
              
            </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../progress/" class="btn btn-neutral float-right" title="LFortran Development Status">Next <span class="icon icon-circle-arrow-right"></span></a>
      
      
        <a href="../installation/" class="btn btn-neutral" title="Installation"><span class="icon icon-circle-arrow-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <!-- Copyright etc -->
    
  </div>

  Built with <a href="https://www.mkdocs.org/">MkDocs</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>.
</footer>
      
        </div>
      </div>

    </section>

  </div>

  <div class="rst-versions" role="note" aria-label="versions">
  <span class="rst-current-version" data-toggle="rst-current-version">
    
    
      <span><a href="../installation/" style="color: #fcfcfc">&laquo; Previous</a></span>
    
    
      <span><a href="../progress/" style="color: #fcfcfc">Next &raquo;</a></span>
    
  </span>
</div>
    <script>var base_url = '..';</script>
    <script src="../js/theme_extra.js" defer></script>
    <script src="../js/theme.js" defer></script>
      <script src="../search/main.js" defer></script>
    <script defer>
        window.onload = function () {
            SphinxRtdTheme.Navigation.enable(true);
        };
    </script>

</body>
</html>
